/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Nodelist searching and retrieval functions                             *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include "prog.h"
#include "max.h"

int pascal NodeExist(int zone,int net,int node)
{
  struct _ndi ndi[NUM_NDI];

  int idxfile,
      offset,
      current_zone,
      x,y;

  char temp[PATHLEN];

  current_zone=prm.address[0].Zone;

  sprintf(temp,idxnode,PRM(net_info));

  if ((idxfile=shopen(temp,O_RDONLY | O_BINARY))==-1)
  {
    logit(cantopen,temp);
    return -1;
  }

  for (offset=0;! eof(idxfile);offset += NUM_NDI)
  {
    y=read(idxfile,(char *)ndi,sizeof(struct _ndi)*NUM_NDI) / sizeof(struct _ndi);

    for (x=0;x < y;x++)
    {
      if (ndi[x].node==-2)
        current_zone=ndi[x].net;

      /* Convert region/zone addresses */
      if (ndi[x].node < 0)
        ndi[x].node=0;

      if ((current_zone==zone || zone==0 || prm.nlver==5) && ndi[x].net==net &&
          ndi[x].node==node)
      {
        close(idxfile);
        return offset+x;
      }
    }
  }

  close(idxfile);
  return -1;
}


int pascal ReadNode(int zone,int net,int node,void *nodeptr)
{
  char temp[PATHLEN];

  int nlfile; /* File handle for nodlist */

  unsigned int offset, /* # of nodes in nodelist file until we come to ours */
               x;

  unsigned long n6size; /* Length of each Version 6 dynamic-length nodelist record */

  if ((offset=NodeExist(zone,net,node))==(unsigned int)-1)
    return FALSE;
  else
  {
    if (prm.nlver==6)
    {
      sprintf(temp,idxnode,PRM(net_info));

      x=(unsigned int)(fsize(temp)/(long)sizeof(struct _ndi));  /* This finds number of nodes in IDX/DAT */

      sprintf(temp,datnode,PRM(net_info));

      n6size=fsize(temp);     /* Calculate the dynamic V6 size by dividing */
      n6size=n6size/(unsigned long)x;  /* total .DAT size by number of nodes */
    }
    else sprintf(temp,sysnode,PRM(net_info));

    if ((nlfile=shopen(temp,O_RDONLY | O_BINARY))==-1)
    {
      logit(cantopen,temp);
      return FALSE;
    }

    lseek(nlfile,((long)offset)*(prm.nlver==6 ? (long)n6size :
          (long)sizeof(struct _node)),SEEK_SET);

    if (read(nlfile,nodeptr,prm.nlver==6 ? sizeof(struct _newnode) :
         sizeof(struct _node)) <= 0)
    {
      close(nlfile);
      logit(cantread,temp);
      return FALSE;
    }

    close(nlfile);

    return TRUE;
  }
}

